
; EK Viewer v1.3
; (c) 1998 Marc Padellini
; marcp@chez.com
; http://www.chez.com/marcp/
	include "doorsos.h"
	include "graphlib.h"
	include "userlib.h"
	
   include "macros.h"

    xdef _main          ; This line tells the assembler that a _main
		                        ; function exists and execution will start at it.
		                        ; Not including this line will cause execution to
		                        ; always start at the first instruction.
    xdef _comment       ; This line tells the assembler that a program
                                         ; comment exists.
    xdef _ti92plus      ; will run on.
		
_main:
				
				MOVE.w #$700,d0 ;  Dsactive toutes les interruptions masquables 
				TRAP #1 ; en armant les bits 8, 9 et 10 du registre SR 
		
				move.b	#0,lance
folderlist:
				jsr	graphlib::clr_scr2   ; on fface l'cran
				move.b  #6,espacefont
				move.b	#1,currentfont
                move.w	#1,invflag
				move.b	#0,finscrldown	;on peut scroller
				move.b	#1,finscrlup	;on peut pas scroller au debut
				move.w	#0,poshoriz		;affichage  fond  droite
				move.w	#0,souligneflag
				move.w	#0,handletxt
				cmp.b	#1,lance
				beq		folderlist1
				move.w	#0,selec	;met  0 la slection
				
				
folderlist1:				move.w	#0,premierv
				move.w  #0,d1	;x1
				move.w  #17,d2	;y
				move.w  #240,d3	;x2

				jsr     linehoriz
				move.w  #0,d1	;x1
				move.w  #0,d2	;y
				move.w  #240,d3	;x2
				jsr     linehoriz
								
                                SetFont #1

				SetFont #1


				WriteStr #78,#8,#4,prgname
				SetFont	#0

                 WriteStr #130,#122,#4,prginfo
				WriteStr #0,#122,#4,prginfo2
		        
				WriteStr #2,#22,#4,sfolder
				WriteStr #64,#22,#4,svar
				;WriteStr #180,#22,#4,stype
				   lea     LCD_MEM+121*30,a0
				       move.l  #$FFFFFFFF,d0
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.l  d0,(a0)+
				       move.w  d0,(a0)+
				
				
				SetFont #1

				
				clr.w	premierf   ;numro du premier sur la liste
				clr	    d4	   ;numro du nom de rpertoire en cours d'affichage

				jsr		affiche		;affiche la liste de rpertoires
				
				jsr		selecfl		;affiche la slection
				
				cmp.b	#1,lance
				beq		selec_varinit
stopaffich:		
				jsr		attente
				jsr		attente
				jsr		GetKeyStat
				
				btst.b	#6,keystat+8	;esc
				beq		fini
				
				btst.b	#6,keystat		;droite
				beq		selec_varinit
				btst.b	#6,keystat+6	;enter
				beq		selec_varinit
				
				btst.b	#4,keystat		;gauche
				beq		stopaffich
				btst.b	#7,keystat		;bas
				beq		basfl
				btst.b	#5,keystat		;haut
				beq		hautfl
				
				
		bra		stopaffich

selec_varinit:
		jsr		attente
		jsr		attente
		cmp		#0,nbrev	;si pas de fichier on revient  la slec des rep
		beq		stopaffich
		clr		selecv		;barre de slec  0
		clr		premierv
		jsr		selecvl		;affiche la slection

		cmp.b	#1,lance
		bne		selec_var
		jsr		affichvar
		jsr		selecvl	

selec_var:
		jsr		attente
		jsr		attente
		
		jsr		GetKeyStat
		
		
		btst.b	#6,keystat+8	;esc
		beq		fini
			
			
			btst.b	#4,keystat		;gauche
			beq		precedent
			btst.b	#7,keystat		;bas
			beq		basvl
			btst.b	#5,keystat		;haut
			beq		hautvl
			beq		pagedown
			btst.b	#6,keystat		;droite	
			beq		viewtxt
			btst.b	#6,keystat+6	;enter	
			beq		viewtxt
			
		bra		selec_var
		
fini:		
;			jsr	gray4lib::off
			MOVE.w #0,D0 ; Active toutes les interruptions masquables 
			TRAP #1 ; en desarmant les bits 8, 9 et 10 du registre SR 

		rts

precedent:
		cmp.b	#1,lance
		beq		precedent1
		jsr		selecvl		;on efface la slection
		move.w	#0,selecv
		bra		folderlist
precedent1:
		move.b	#0,lance
		move.w	#0,selec
		move.w	#0,selecv
		bra		folderlist


GetKeyStat:
 movem.l d0-d1/a0,-(a7)
 lea	 keystat(PC),a0
 move.w  #$FFFE,d0
 moveq	 #9,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 rol.w	 #1,d0
 dbra	 d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts

attente:
		move.l	#20000,d0
		
attenteb:
		nop
		dbra	d0,attenteb
		rts

;attente2:  ;attend pas longtemps. JUste pour la synchro des touches.
;		move.l	#2000,d0
;		
;attente2b:
;		nop
;		dbra	d0,attente2b
;		rts
;
attentetxt:
		move.l	attenteval,d0
		
attentetxtb:
		nop
		dbra	d0,attentetxtb
		rts


affiche:
				jsr		clrfolder
				move.l	#8,d0		;handle n08 (Ti92Plus)
				DEREF	d0,a2
				adda.l	#2,a2
				move.w	(a2),nbre ;nombre de rpertoires
				adda.l	#2,a2
				move.l	a2,debutl  ;au sauve l'adresse du dbut de la liste de rpertoires
				clr 	d3
				move.l	#30,d3		;y=30
				move.w	premierf,d4
affich:			
				move.l	d4,d5
				mulu	#14,d5  ;14 octets par rpertoire
				move.l	debutl,a2
				adda.l	d5,a2
				clr d0
				move.l  #7,d0	   ;8 lettres
				lea nom(pc),a0  ;on copie le nom du 1er rpertoire dans nom
				
copienom:
				move.b (a2)+,(a0)+
				DBRA d0,copienom
				
				move.w  #4,-(a7)        ; mode criture N/B dans la pile
				lea     nom(pc),a0  	; a0 pointe sur la chane de caractres
				move.l  a0,-(a7)        ; a0 dans la pile
				move.w  d3,-(a7)        ; posY
				move.w  #2,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				addq.l	#1,d4			;un nom de rpertoire a t affich
				addi.l	#10,d3			;ligne suivante
				
				move.w	premierf,d0
				move.l	d4,d1
				sub		d0,d1	
				cmp 	#9,d1
				beq 	affichvar
				cmp 	nbre,d4				;tant que c'est moins que le nombre on affiche 				
				blt 	affich	
affichvar:
				jsr		clrvar			;efface l'affichage pour les variables
				clr		d0
				move.w	selec,d0
				addq	#1,d0
				mulu	#14,d0
				add.l	debutl,d0
				subq	#2,d0
				move.l	d0,a0
				clr		d0
				move.w	(a0),d0
				DEREF	d0,a2 ;-c juste
				adda.l	#2,a2
				move.w	(a2),nbrev ;nombre de fichiers
				move.w	nbrev,d0
				cmp		#0,d0
				beq		affichvarend
				adda.l	#2,a2
				move.l	a2,debutlv  ;au sauve l'adresse du dbut de la liste de rpertoires
				clr 	d3
				move.l	#30,d3		;y=30
				move.w	premierv,d4
				
affichv:			
				move.l	d4,d5
				mulu	#14,d5  ;14 octets par rpertoire
				move.l	debutlv,a2
				adda.l	d5,a2
				
				;

				move.l	d4,d0
				addq	#1,d0
				mulu	#14,d0
				add.l	debutlv,d0
				subq	#2,d0
				move.l	d0,a0
				clr		d0
				move.w	(a0),d0
				DEREF	d0,a4 ;-on a l'adresse du dbut du fichier dans a4
				
				move.l	a4,-(a7)
				
				clr.l   d1			;on teste si c'est un texte
                move.w  (a4),d1
				
				cmp.b	#64,5(a4)
				bne		affwrong
                
				add.l   d1,a4
                addq.l  #1,a4
                move.b  (a4),d1
                move.b	#1,d0
                cmp.b   #$E0,d1
                beq     afftrue    ;1 dans d0 si c'est un texte
affwrong:
                clr	    d0
afftrue:
				move.l  (a7)+,a4

				cmp.b	#0,d0
				beq		afftypenom

				move.w	#64,d7
				addq	#6,a4
				cmp.b	#169,(a4)
				bne		afftrue@1
				addq	#1,a4
afftrue@1:
				cmp.b	#35,(a4)
				bne		afftrue2

afftrue@:
				addq	#2,a4
afftrue2:		
				move.b (a4)+,charactere
				
				cmp.b	#$0D,charactere
				beq		afftypeend

				cmp.b	#35,charactere
				beq		afftypeend

				cmp.b	#$00,charactere
				beq		afftypeend
				
				
				move.w  #4,-(a7)        ; mode criture N/B dans la pile
				lea     charactere(pc),a5  	; a0 pointe sur la chane de caractres
				move.l  a5,-(a7)        ; a0 dans la pile
				move.w  d3,-(a7)        ; posY
				move.w  d7,-(a7)      ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile

				addq	#6,d7
				cmp		#240,d7
				beq		afftypeend
				bra		afftrue2

				;				
afftypenom:
				clr d0
				move.l  #7,d0	   ;8 lettres
				lea nom(pc),a0  ;on copie le nom du 1er rpertoire dans nom
				
copienomv:
				move.b (a2)+,(a0)+
				DBRA d0,copienomv
				
				move.w  #4,-(a7)        ; mode criture N/B dans la pile
				lea     nom(pc),a0  	; a0 pointe sur la chane de caractres
				move.l  a0,-(a7)        ; a0 dans la pile
				move.w  d3,-(a7)        ; posY
				move.w  #64,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
afftypeend:						  		
				
				addq.l	#1,d4			;un nom de rpertoire a t affich
				addi.l	#10,d3			;ligne suivante
				
				move.w	premierv,d0
				move.l	d4,d1
				sub		d0,d1	
				cmp 	#9,d1
				beq 	affichvarend
				cmp 	nbrev,d4				;tant que c'est moins que le nombre on affiche 				
				blt 	affichv	
affichvarend:	
				rts

clrfolder:  ;efface l'affichage en cours pour les rpertoires
		;IN:	d0=X
		;		d1=Y
		move.l	#2,d0
		move.l	#30,d1
		lea		LCD_MEM,a0	;adresse de la mem vido
		mulu	#240,d1		;pixel: 240*y
		add.w	d0,d1		;+x		
		divu	#8,d1
		add.w	d1,a0		;a5 pointe sur le premier pixel  inverser
		move.l	#89,d0
clrfolder2:
		clr.b	(a0)+		;Attention! Si on met not.w il y a plantage!
		clr.b	(a0)+
		clr.b	(a0)+
		clr.b	(a0)+
		clr.b	(a0)+
		clr.b	(a0)+
		clr.b	(a0)+
		adda	#23,a0		;change de ligne
		dbra d0,clrfolder2
		rts

clrvar:  ;efface l'affichage en cours pour les fichiers
		;IN:	d0=X
		;		d1=Y
		move.l	#64,d0
		move.l	#30,d1
		lea		LCD_MEM,a0	;adresse de la mem vido
		mulu	#240,d1		;pixel: 240*y
		add.w	d0,d1		;+x		
		divu	#8,d1
		add.w	d1,a0		;a5 pointe sur le premier pixel  inverser
		move.l	#89,d0
clrvar2:
		move.l	#21,d1
clrvar2@
		clr.b	(a0)+		;Attention! Si on met not.w il y a plantage!
		dbra	d1,clrvar2@
		
		adda	#8,a0		;change de ligne
		dbra 	d0,clrvar2

		rts
				
bande:  ;affiche en vido inverse un endroit
		;IN:	d0=X
		;		d1=Y

		lea		LCD_MEM,a0	;adresse de la mem vido
		mulu	#240,d1		;pixel: 240*y
		add.w	d0,d1		;+x		
		divu	#8,d1
		add.w	d1,a0		;a5 pointe sur le premier pixel  inverser
		move.l	#9,d0
bande2:
		not.b	(a0)+		;Attention! Si on met not.w il y a plantage!
		not.b	(a0)+
		not.b	(a0)+
		not.b	(a0)+
		not.b	(a0)+
		not.b	(a0)+
		not.b	(a0)+
		adda	#23,a0		;change de ligne
		dbra d0,bande2
		rts

hautfl:	;on fait monter la slection
		clr		d1
		move.w	selec,d1
		addq	#1,d1
		cmp 	#1,d1		;si slection=1
		bls		stopaffich	;on ne peut pas monter
		
		jsr 	selecfl		;on efface la barre de slection
							;si slection=premier de la liste affich
		move.w	premierf,d6
		cmp		selec,d6	;alors dfiler la liste vers le haut
		beq		hautflscroll
		
		;on dfile vers le haut la bande de slection
		subq	#1,selec
		jsr		affichvar	;on affiche les variables du rp correspondant  la slection
		jsr		selecfl		;on la raffiche  ct
		
		bra		stopaffich
		
hautflscroll:
		subq	#1,selec
		sub		#1,premierf		;le premier de la liste est le prcdent
		move.w	premierf,d4
		jsr		affiche
		jsr		selecfl		;on raffiche la slection
		bra		stopaffich

basfl:	;on fait descendre la slection
		clr		d1
		move.w	selec,d1
		addq	#1,d1
		cmp 	nbre,d1	;si slection=nombre total de noms alors
		bge		stopaffich	;on ne peut pas descendre
		
		jsr 	selecfl		;on efface la barre de slection
		move.w 	premierf,d0	;si slection=dernier de la liste affich
		addi 	#8,d0
		cmp		selec,d0	;alors dfiler la liste vers le bas
		beq		basflscroll
		
		;on dfile vers le bas la bande de slection
		addq	#1,selec
		jsr		affichvar	;on affiche les variables du rp correspondant  la slection
		jsr		selecfl		;on la raffiche  ct
		
		bra		stopaffich
		
basflscroll:
		addq	#1,selec
		add		#1,premierf		;le premier de la liste est le suivant
		move.w	premierf,d4
		jsr		affiche
		jsr		selecfl		;on raffiche la slection
		bra		stopaffich
	
	

selecfl:					;affiche la barre de slection pour la liste
		move.l	#2,d0		;de rpertoires
		clr		d1
		move.w	selec,d1
		sub		premierf,d1
		mulu	#10,d1
		addi	#30,d1
		jsr		bande
		rts

hautvl:	;on fait monter la slection
		clr		d1
		move.w	selecv,d1
		addq	#1,d1
		cmp 	#1,d1		;si slection=1
		bls		selec_var	;on ne peut pas monter
		
		jsr 	selecvl		;on efface la barre de slection
							;si slection=premier de la liste affich
		move.w	premierv,d6
		cmp		selecv,d6	;alors dfiler la liste vers le haut
		beq		hautvlscroll
		
		;on dfile vers le haut la bande de slection
		subq	#1,selecv
		jsr		selecvl		;on la raffiche  ct
		
		bra		selec_var
		
hautvlscroll:
		subq	#1,selecv
		sub		#1,premierv		;le premier de la liste est le prcdent
		move.w	premierv,d4
		jsr		affichvar
		jsr		selecvl		;on raffiche la slection
		bra		selec_var

basvl:	;on fait descendre la slection
		clr		d1
		move.w	selecv,d1
		addq	#1,d1
		cmp 	nbrev,d1	;si slection=nombre total de noms alors
		bge		selec_var	;on ne peut pas descendre
		
		jsr 	selecvl		;on efface la barre de slection
		move.w 	premierv,d0	;si slection=dernier de la liste affich
		addi 	#8,d0
		cmp		selecv,d0	;alors dfiler la liste vers le bas
		beq		basvlscroll
		
		;on dfile vers le bas la bande de slection
		addq	#1,selecv
		jsr		selecvl		;on la raffiche  ct
		
		bra		selec_var
		
basvlscroll:
		add		#1,selecv
		add		#1,premierv		;le premier de la liste est le suivant
		move.w	premierv,d4
		move.l	#30,d3
		jsr		affichvar
		jsr		selecvl		;on raffiche la slection
		bra		selec_var
	
selecvl:					;affiche la barre de slection pour la liste
		move.l	#64,d0		;de fichiers
		clr		d1
		move.w	selecv,d1
		sub		premierv,d1
		mulu	#10,d1
		addi	#30,d1
		
		lea		LCD_MEM,a0	;adresse de la mem vido
		mulu	#240,d1		;pixel: 240*y
		add.w	d0,d1		;+x		
		divu	#8,d1
		add.w	d1,a0		;a5 pointe sur le premier pixel  inverser
		move.l	#9,d0
bande2selec:
		move.l	#21,d1
bande2@selec:
		not.b	(a0)+		;Attention! Si on met not.w il y a plantage!
		dbra	d1,bande2@selec
		adda	#8,a0		;change de ligne
		dbra d0,bande2selec
		
		rts

linehoriz:
 			    movem.l d0-d1/a0,-(a7)

        
                move.w  d1,d4
        next:   move.w  d2,-(a7)
                move.w  d1,-(a7)
                jsr     flib::pixel_on
                lea     4(a7),a7
                add.w   #1,d1
                cmp.w   d1,d3
                bne     next
                move.w  d4,d1
 				movem.l (a7)+,d0-d1/a0 
 rts

linevert:
                move.w  d2,d4
        next2:  move.w  d2,-(a7)
                move.w  d1,-(a7)
                jsr     flib::pixel_on
                lea     4(a7),a7
                add.w   #1,d2
                cmp.w   d2,d3
                bne     next2
                move.w  d4,d2
                rts

				
;----------------------------------------------------------------------------------------
; ICI LES ROUTINES D'AFFICHAGE DU TEXTE
;----------------------------------------------------------------------------------------
viewtxt:
 
				jsr		attente
				jsr		attente
				jsr		attente
				clr		d0
				move.w	selecv,d0
				addq	#1,d0
				mulu	#14,d0
				add.l	debutlv,d0
				subq	#2,d0
				move.l	d0,a0
				clr		d0
				move.w	(a0),d0
				DEREF	d0,a2 ;-on a l'adresse du dbut du fichier dans a2
					;en passant: c'est du dlire: si on met a4 ou a5 ca fait planter le prog
					;gant non ?
				
				move.l	a2,a4
				
				clr.l   d1			;on teste si c'est un texte
                move.w  (a4),d1
		
				;cmp.b	#64,5(a4)
				;bne		affwrongt

				add.l   d1,a4
                addq.l  #1,a4
                move.b  (a4),d1
                cmp.b   #$E0,d1
                beq     afftruet    ;1 dans d0 si c'est un texte
affwrongt:
				bra		selec_var
				
afftruet:
                                jsr     graphlib::clr_scr

				clr.l	d0
				move.w	(a2),d0
				move.l	a2,d1
				add		d1,d0
				move.l	d0,fintxt
				adda	#5,a2		;on saute le header du fichier
				move.b	(a2),d0
				cmp.b	#64,d0
				bne		viewtxtptr
				addq	#1,a2
viewtxtptr:
				move.l	a2,debuttxt
				lea		charactere(pc),a3

boucletxt1:
				jsr		sautedroite
				move.l	#1,d5 ;y
				move.l	#0,d4 ;x
				clr.w	compt ; nombre de car affichs sur la ligne
boucletxt:
				move.b	(a2)+,d0
				jsr		doinv
				move.b	d0,(a3)
				
				
				cmp.b	#0,d0			;fin du fichier ?
				beq		finscroll
				
							
				cmp.b	#$0D,d0			;retour de chariot ?
				beq		newline
				
				cmp.b	#2,currentfont
				bne		boucletxtsimple
				
				subq	#1,d4
				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				addq	#1,d4

boucletxtsimple:				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				jsr		moins		;on rallonge un peu plus les moins
				
				jsr		souligner	;on souligne si ncessaire
								
				add		#1,compt		;1 char affich
				move.w	limitfont,d0
				cmp.w	compt,d0		;est-ce qu'on a affich le max de caractre sur la ligne ?
				beq		newlinebis
				add.b	espacefont,d4
				bra		boucletxt
				
newlinebis:
				jsr		seeklinedown
				subq	#1,a2
newline:		
				add		#8,d5			;ligne suivante y+8
				clr		d4				;x=0
				cmp.b	#0,d0			;fin du fichier ?
				beq		boucletxtend
				addq	#1,a2			;on saute le $20
				cmp		#121,d5			;fin de l'cran ?
				beq		boucletxtend
				jsr		sautedroite
				clr		compt
				bra		boucletxt
				
boucletxtend:
				
				
viewtxtkeyb:	;toutes les op excutes on attend une touche.
				jsr		GetKeyStat
				
				
				btst.b	#6,keystat+6		;enter on quitte
				beq		quittxt
				btst.b	#0,keystat+6
				beq		pagedroite
				btst.b	#7,keystat+5
				beq		pagegauche
				btst.b	#6,keystat+8	;esc	(page up)
				beq		pageup
				btst.b	#6,keystat+7	;apps	(page down)
				beq		pagedown
				;btst.b	#6,keystat		;droite
				;beq		droitetxt
				;btst.b	#4,keystat		;gauche
				;beq		gauchetxt
				btst.b	#7,keystat		;bas
				beq		bastxt
				btst.b	#5,keystat		;haut
				beq		hauttxt
				btst.b	#5,keystat+7	;clear (off)
				beq		turn_off
				btst.b	#0,keystat+0	;2nd	(top)
				beq		totalup
				btst.b	#5,keystat+6	;ln		(don't work)
				beq		totaldown
				;btst.b	#1,keystat+3		;main	(copier la ligne dans le clipboard)
				;beq		grabline
				
				bra		viewtxtkeyb

turn_off:
				trap    #4
				bra		viewtxtkeyb
quittxt:
				
quittxtend:

				move.b	#1,lance
				bra		folderlist

				
hauttxt: ;on scroll tout de 8 pixels vers le bas (1 pixel 8 fois pour le smooth scrolling)
				
				jsr		attentetxt
				
				cmp.b	#1,finscrlup
				beq		viewtxtkeyb
				
				
				move.l	#7,d6	
				lea		LCD_MEM,a0 ;113ime ligne dernier bit
				add		#3390,a0 ;D3E
				move.l	a0,d7
hauttxtboucle1:				
				move.l	d7,a0
				move.l	#$34f,d1  ;34f
				move.l	a0,a1
				adda	#240,a1 ;30
hauttxtboucle:
				move.l	-(a0),-(a1)
				dbra	d1,hauttxtboucle
				add		#30,d7
				;dbra	d6,hauttxtboucle1
				
				;on efface la dernire ligne
				
				lea		LCD_MEM,a1
				move.l	#269,d1 ;269
hauttxtbouc:
				move.b	#0,(a1)+
				dbra	d1,hauttxtbouc

				;on saute ce qu'il faut en arrire
				move.l	a2,-(a7)
				move.l	#15,d7 ;15
hautsaute:
				jsr		seeklineup
				dbra	d7,hautsaute
				
				cmp.b	#1,finscrldown
				bne		hauttxt1
				
				jsr 	seeklinedown
				;move.b	#0,finscrldown ;on premet de descendre  nouveau

hauttxt1:
				
				jsr		sautedroite
				move.l	#1,d5
				move.l	#0,d4
				clr		compt
				;on crit la ligne
boucletxthaut:
				move.b	(a2)+,d0
				jsr		doinv
				move.b	d0,(a3)
				
				cmp.b	#$0D,d0			;retour de chariot ?
				beq		nwlinehaut
				
				cmp.b	#2,currentfont
				bne		boucletxtsimple2
				
				subq	#1,d4
				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				addq	#1,d4

boucletxtsimple2:			
				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile

				jsr		moins		;on rallonge un peu plus les moins				
				jsr		souligner	;on souligne si ncessaire
				
				add.b	espacefont,d4
				addq	#1,compt
				move.w	limitfont,d0
				cmp.w	compt,d0
				beq		nwlinehautbis
				bra		boucletxthaut
nwlinehautbis:
				jsr		seeklinedown
				subq	#1,a2
				clr		compt
nwlinehaut:
				addq	#1,a2
				clr.l	d0
				move.l	#13,d7

			;il faut aller 14 lignes en bas
				move.l	(a7)+,a2
				jsr		seeklineup
				
				cmp.b	#1,finscrldown
				bne		hauttxt2
				
				jsr 	seeklinedown
				move.b	#0,finscrldown ;on premet de descendre  nouveau

hauttxt2:
				bra		viewtxtkeyb

seeklineup:	;fait pointer a2  la ligne prcdente
				clr.l	d0
				clr.l	d1
				;il faut aller 2 lignes avant

seeklineup1:
				cmp.l	debuttxt,a2
				beq		seeklinedebutup

				move.b	-(a2),d0

				cmp.b	#$0D,d0
				beq		seeklinefoundup
				bra		seeklineup1
seeklinedebutup:
				move.b	#1,finscrlup
				bra		seeklineendup

seeklinefoundup:
				addq	#1,d1
				cmp		#2,d1
				bne		seeklineup1

				addq	#2,a2
seeklineendup:
				rts

seeklinedown: ;fait pointer a2  la ligne suivante
				clr.l	d0
				clr.l	d1
				;il faut aller 1 lignes aprs

seeklinedown1:
				;cmp.l	#0,a2
				;beq		seeklinefindown
				move.b	(a2)+,d0

				cmp.b	#$0D,d0
				beq		seeklinefounddown
				bra		seeklinedown1
seeklinefindown:
				move.b	#1,finscrldown
				bra		seeklineenddown
seeklinefounddown:
				addq	#1,a2				
seeklineenddown:
				rts


bastxt: ;on scroll tout de 8 pixels vers le haut

				jsr		attentetxt
				cmp.b	#1,finscrldown			;fin du fichier ?
				beq		viewtxtkeyb
				move.b	#0,finscrlup
				
				
				move.l	#7,d6
				lea		LCD_MEM,a0
				add		#$10E,a0
				move.l	a0,d7
				 ;9ime ligne premier bit
				
bastxtboucle1:				
				move.l	d7,a0
				move.l	#$383,d1  ;347
				move.l	a0,a1
				suba	#240,a1 ;240
bastxtboucle:
				move.l	(a0)+,(a1)+
				dbra	d1,bastxtboucle
				sub		#30,d7
				;dbra	d6,bastxtboucle1
				
				;on efface la dernire ligne
				
				lea		LCD_MEM+3480,a1 ;593E 3450
				move.l	#209,d1 ;239
bastxtbouc:
				move.b	#0,(a1)+
				dbra	d1,bastxtbouc
				
				jsr		sautedroite
				move.l	#113,d5
				move.l	#0,d4
				move.w	#0,compt
boucletxtbas:
				move.b	(a2)+,d0
				jsr		doinv
				move.b	d0,(a3)
				
				cmp.b	#$0D,d0			;retour de chariot ?
				beq		nwlinebas
				
				cmp.b	#0,d0
				beq		finscroll
				
				cmp.b	#2,currentfont
				bne		boucletxtsimple3
				
				subq	#1,d4
				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				addq	#1,d4

boucletxtsimple3:
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile

				jsr		moins		;on rallonge un peu plus les moins				
				jsr		souligner	;on souligne si ncessaire
				
				
				add.b	espacefont,d4
				addq	#1,compt
				move.w	limitfont,d0
				cmp.w	compt,d0
				beq		nwlinebasbis
				bra		boucletxtbas
nwlinebasbis:
				jsr		seeklinedown
				subq	#1,a2
				clr		compt
nwlinebas:
				addq	#1,a2
				bra		viewtxtkeyb
finscroll:
				;jsr		seeklinedown 
				move.b	#1,finscrldown
				bra		viewtxtkeyb

attenteplus:
				cmp		#30000,attenteval
				beq		viewtxtkeyb
				add.l	#1000,attenteval
				bra		viewtxtkeyb
attentemoins:
				cmp		#0,attenteval
				beq		viewtxtkeyb
				sub.l	#1000,attenteval
				bra		viewtxtkeyb

pagedown:
				cmp.b	#1,finscrldown
				beq		viewtxtkeyb
				move.b	#0,finscrlup
                                jsr     graphlib::clr_scr
				bra		boucletxt1
				
pageup:
				;cmp.b		#1,finscrlup
				;beq		viewtxtkeyb
				move.b	#0,finscrldown
                                jsr     graphlib::clr_scr
				move.l	#28,d7
pageup1:
				jsr	seeklineup
				dbra	d7,pageup1
				bra		boucletxt1
				
totaldown:
				;jsr		seeklinedown
				;cmp		#0,a2
				;bne		totaldown
				;jsr		util::zap_screen
				;move.b	#0,finscrlup
				;move.b	#1,finscrldown
				
				;move.l	#15,d5
;totaldown1:
;				jsr	seeklineup			
;				dbra	d5,totaldown1

;				bra		boucletxt1
				bra		viewtxtkeyb

totalup:
                                jsr     graphlib::clr_scr
				move.b	#1,finscrlup
				move.b	#0,finscrldown
				move.l	debuttxt,a2
				bra		boucletxt1

gauchetxt:
				cmp		#0,poshoriz
				beq		viewtxtkeyb
                                jsr     graphlib::clr_scr
				sub		#1,poshoriz
				bra		horiztxt
droitetxt:
                                jsr     graphlib::clr_scr   ; on fface l'cran
				add		#1,poshoriz
horiztxt:				
				;on saute ce qu'il faut en arrire
				clr.l	d2
				move.l	a2,-(a7)
				move.l	#14,d7
droitehautptr:
				jsr		seeklineup
				dbra	d7,droitehautptr
				
				move.l	#1,d5 ;y
				move.l	#0,d4 ;x
				clr.w	compt
				jsr		sautedroite ;on saute a2  l'endroit o il faut
				
boucletxtdroite:
				move.b	(a2)+,d0
				;jsr		doinv
				move.b	d0,(a3)
								
				cmp.b	#0,d0			;fin du fichier ?
				beq		sautebasdroite
				
							
				cmp.b	#$0D,d0			;retour de chariot ?
				beq		newlinedroite
				
				move.w	invflag,d1
				move.w  d1,-(a7)        ; mode criture N/B dans la pile
				move.l  a3,-(a7)        ; a3 dans la pile
				move.w  d5,-(a7)       ; posY
				move.w  d4,-(a7)       ; posx
				jsr	doorsos::DrawStrXY ; affiche le tout
				lea     10(a7),a7		;raz de la pile
				
				add		#1,compt		;1 char affich
				move.w	limitfont,d0
				cmp.w	compt,d0		;est-ce qu'on a affich le max de caractre sur la ligne ?
				beq		newlinebisdroite
				add.b	espacefont,d4
				bra		boucletxtdroite
				
newlinebisdroite:
				jsr		seeklinedown
				subq	#1,a2
newlinedroite:		
				add		#8,d5			;ligne suivante y+8
				clr		d4				;x=0
				cmp.b	#0,d0			;fin du fichier ?
				beq		viewtxtkeyb
				addq	#1,a2			;on saute le $20
				jsr		sautedroite
				cmp		#121,d5			;fin de l'cran ?
				beq		sautebasptr
				clr		compt
				bra		boucletxtdroite
sautebasptr:
				clr.l	d0
				move.l	#13,d7

			;il faut aller 14 lignes en bas

sautebasdroite:
;				jsr		seeklinedown
;				dbra	d7,sautebasdroite
				move.l	(a7)+,a2
				bra		viewtxtkeyb

sautedroite:
				cmp		#0,poshoriz ; si rien  sauter on saute rien
				beq		sautedroitenwline
				clr.l	d6
				move.w	poshoriz,d6
				subq	#1,d6
sautedroitebouc:
				move.b	(a2),d0
				cmp		#$0D,d0
				beq		sautedroitenwline
				cmp		#0,a2
				beq		sautedroitenwline	
				addq	#1,a2
				dbra	d6,sautedroitebouc
sautedroitenwline:
								
				rts

pagedroite:
				add.w	#39,poshoriz
				move.l	#14,d7
pagedroiteptr:
				jsr		seeklineup
				dbra	d7,pagedroiteptr
                                jsr     graphlib::clr_scr
				jsr		attente
				jsr		attente
				bra		boucletxt1

pagegauche:
				cmp.w	#0,poshoriz
				beq		viewtxtkeyb
				
				cmp.w	#39,poshoriz
				ble		pagegaucheend
				
				sub.w	#39,poshoriz
				bra		pagegauchenormal
pagegaucheend:				
				move.w	#0,poshoriz
pagegauchenormal:
				move.l	#14,d7
pagegaucheptr:
				jsr		seeklineup
				dbra	d7,pagegaucheptr
                                jsr     graphlib::clr_scr
				jsr		attente
				jsr		attente
				bra		boucletxt1

;grabline:
;				;on saute ce qu'il faut en arrire
;				clr.l	d2
;				move.l	a2,-(a7)
;				move.l	#14,d7
;grablineup:
;				jsr		seeklineup
;				dbra	d7,grablineup
;				
;				move.l	#11,d0		;handle n011 (clipboard)
;				DEREF	d0,a1
;grablineboucl:
;				move.b	(a2)+,d0
;				cmp		#13,d0
;				beq		grablineend
;				move.b	d0,(a1)+
;				
;				bra		grablineboucl
;				
;grablineend:
;				lea		signature(pc),a4
;grabboucl2:
;				move.b	(a4)+,d0
;				cmp		#13,d0
;				beq		grablinevend
;				move.b	d0,(a1)+
;				bra		grabboucl2
;grablinevend:
;				
;				move.l	(a7)+,a2
;				bra		viewtxtkeyb

encadretest:
				cmp.b	#169,d0
				bne		encadretestend
				
				movem.b	finscrlup,-(a7)
				movem.l d0-d7/a0-a7,-(a7)
				
				move.l	debuttxt,d1
				addq	#1,d1
				cmp.l	d1,a2
				beq		encadreligneup2
				jsr		seeklineup
				move.b	(a2),d0
				cmp.b	#169,d0
				beq		encadrebarre
				
				bra		encadreligneup
				
encadrebarre:
				move.l	#0,d1	;x
				move.l	d5,d2	;y1
				move.l	d5,d3	;y2
				add		#8,d3
				jsr		linevert
				move.l	#239,d1
				jsr		linevert
				jsr		seeklinedown
				bra		encadrerfin
				
encadreligneup:
				jsr		seeklinedown

encadreligneup2:
				move.l	#0,d1	;x
				move.l	d5,d2	;y1
				move.l	d5,d3	;y2
				add		#8,d3
				jsr		linevert
				
				move.l	#239,d1
				jsr		linevert
				
				move.l	#0,d1	;x1
				move.l	#239,d3	;x2
				move.l	d5,d2
				jsr		linehoriz

				
				bra		encadrerfin
encadrerfin:
				jsr		seeklinedown
				move.b	(a2),d0
				cmp.b	#169,d0
				beq		encadrefin2
				
				move.l	#0,d1	;x1
				move.l	#239,d3	;x2
				move.l	d5,d2
				add		#7,d2
				jsr		linehoriz
				
encadrefin2:
				movem.l	(a7)+,d0-d7/a0-a7
				movem.b	(a7)+,finscrlup
				move.b	(a2)+,d0
encadretestend:
				rts
				
doinv:	;on inverse l'criture
				
				cmp		#0,d4
				jsr		encadretest

				cmp.b	#35,d0		;si "#" on reste
				bne		doinvend
				
				cmp.b	#66,(a2)	;si "#B" on met big font
				beq		changefont
				
				cmp.b	#85,(a2)	;on souligne
				beq		dosouligne
				
				
				cmp.b	#73,(a2)	;si "#I" on inverse
				bne		doinvendblam
				
				
				cmp.w	#0,invflag
				beq		invnormal
				
				move.w	#0,invflag
				addq	#1,a2
				move.b	(a2)+,d0
				bra		doinvend
invnormal:		
				move.w	#1,invflag
				addq	#1,a2
				move.b	(a2)+,d0
				bra		doinvend

dosouligne:
				cmp.w	#0,souligneflag
				beq		soulignenormal

				move.w	#0,souligneflag
				addq	#1,a2
				move.b	(a2)+,d0
				bra		doinvend
soulignenormal:
				move.w	#1,souligneflag
				addq	#1,a2
				move.b	(a2)+,d0
				bra		doinvend

changefont:
				cmp.b	#1,currentfont
				beq		viewtxtfont1

				move.b	#1,currentfont				
				move.b	#6,espacefont
				move.w	#40,limitfont
				bra		viewtxtfont0
viewtxtfont1:
				move.b	#2,currentfont
				move.b	#7,espacefont
				move.w	#34,limitfont
viewtxtfont0:
				clr.l	d0
				move.b	currentfont,d0
				;move.w  d0,-(a7)
				;jsr tios::FontSetSys
 				;lea		2(a7),a7
				addq	#1,a2
				move.b	(a2)+,d0

doinvend:
				cmp.b	#35,d0		;si "#" on recommence
				beq		doinv

doinvendblam:
				rts				


moins:
				movem.l d0-d1/a0,-(a7)
				move.b	(a2),d0
				cmp.b	#45,charactere ;c'est un signe - ?
				bne		moinsend
				
				cmp.b	#22,d0
				beq		moinsfl
				
				cmp.b	#45,d0
				bne		moinsend
				
moinsfl:

				move.l  d4,d1	;x1
				move.l  d5,d2	;y
				move.l  d4,d3	;x2
				add		#3,d2	;on va 
				add		#8,d3

				bsr     linehoriz


				
moinsend:
				movem.l (a7)+,d0-d1/a0
				rts

souligner:
				movem.l d0-d1/a0,-(a7)
				
       			cmp.w	#1,souligneflag
		   		bne		soulignerend



				move.l  d4,d1	;x1
				move.l  d5,d2	;y
				move.l  d4,d3	;x2
				add		#7,d2	;on va 
				add		#8,d3
				
				bsr     linehoriz
		
soulignerend:
				movem.l (a7)+,d0-d1/a0
				rts

;copierLCD:
;				movem.l d0-d1/a0,-(a7)
;				move.l	gray4lib::plane0,a1
;				lea		LCD_MEM,a0
;				move.l	#959,d1 ;960
;
;copierLCD@1:
;				move.l	(a0)+,d0
;				move.l	d0,(a1)+
;				dbra	d1,copierLCD@1
;				
;				movem.l (a7)+,d0-d1/a0
;				rts




debutl:				;adresse de la liste de rpertoires
		dc.l 0
		
debutlv:			;adresse de la liste de fichiers
		dc.l 0
debuttxt:			;adresse du dbut des donnes texte
		dc.l 0
fintxt:				;adresse de la fin des donnes texte
		dc.l 0

attenteval:
		dc.l 0
		
selec:				;numro du rp slectionn
		dc.w 0
selecv:				;numro du fichier slectionn
		dc.w 0
nbre:				;nombre de rpertoires
		dc.w 0
nbrev:				;nombre de fichiers
		dc.w 0
poshoriz:		;position horizontale (flche droite appuye x fois)
		dc.w 0

premierf:
		dc.w 0
premierv:
		dc.w 0
invflag:
		dc.w 1
souligneflag:
		dc.w 0
compt:
		dc.w 0
limitfont:
		dc.w 40
		
handletxt:
		dc.w 0
		
charactere:
		dc.b 0,0,0
		
keystat	ds.b 10

nom:
		dc.b 0,0,0,0,0,0,0,0,0
prgname:
                dc.b "EKViewer v1.3",0
prginfo:
                dc.b "        www.chez.com/ekviewer",0
prginfo2:             
                dc.b "Copyright ",169,"1999 Marc Padellini",0
sfolder:
		dc.b "FOLDERS",0
svar:
		dc.b "VARS",0
stext:
		dc.b "TEXT",0
stype:
		dc.b "TYPE",0
finscrlup:
		dc.b 0
espace:
		dc.b 20,0
;shareware:
		dc.b 3

finscrldown:
		dc.b 0
lance:			;indique si l'on retourne d'un affichage de texte ou si on a lanc le prgm
		dc.b 0	;depuis la premire fois
;signature:
;		dc.b 0,34,6,0,8,233,0,"Done",0,236,0,29,0,8,0,0,0,9,13
currentfont:
		dc.b 1
espacefont:
		dc.b 6
_comment:
    dc.b "EKViewer v1.3 Marc Padellini",0


		end
